#**************************************************************************
#   Copyright (C) 2009 by Michael Andreen <harvATruinDOTnu>               *
#                                                                         *
#   This program is free software; you can redistribute it and/or modify  *
#   it under the terms of the GNU General Public License as published by  *
#   the Free Software Foundation; either version 2 of the License, or     *
#   (at your option) any later version.                                   *
#                                                                         *
#   This program is distributed in the hope that it will be useful,       *
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#   GNU General Public License for more details.                          *
#                                                                         *
#   You should have received a copy of the GNU General Public License     *
#   along with this program; if not, write to the                         *
#   Free Software Foundation, Inc.,                                       *
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
#**************************************************************************/

package NDIRC::Command;
use strict;
use warnings;

use Moose;

has acl => (
	is => 'ro',
	isa => 'ArrayRef[Str]',
	predicate => 'has_acl',
);

has type => (
	is => 'ro',
	isa => 'ArrayRef[Str]',
	default => sub { ['pub'] },
);

has help => (
	is => 'ro',
	isa => 'ArrayRef[Str]',
	default => sub{ ['No help for this command'] },
);

has name => (
	is => 'ro',
	isa => 'Str',
	default => 'No help for this command',
);

has func => (
	is => 'ro',
	isa => 'CodeRef',
	required => 1,
);

sub execute {
	my ($self,$c,$args) = @_;
	$self->func->(@_);
}

1;
